#pragma once

namespace Ra {
namespace Engine {
namespace Rendering {
/**
 * Defines the families of objects for rendering.
 */
enum class RenderObjectType {
    /// "Ui" render objects are drawn on top of everything else and view independant
    UI = 0,
    /// "Debug" render objects are drawn like any other object (not lit though)
    Debug,
    /// "Geometry" render objects are those loaded using Radium::IO and generated by GeometrySystem
    Geometry,

    Count
};

} // namespace Rendering
} // namespace Engine
} // namespace Ra
